Index: lemon/connectivity.h
===================================================================
--- lemon/connectivity.h	(revision 559)
+++ lemon/connectivity.h	(revision 586)
@@ -33,5 +33,5 @@
 #include <functional>
 
-/// \ingroup connectivity
+/// \ingroup graph_properties
 /// \file
 /// \brief Connectivity algorithms
@@ -41,5 +41,5 @@
 namespace lemon {
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Check whether the given undirected graph is connected.
@@ -64,5 +64,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Count the number of connected components of an undirected graph
@@ -106,9 +106,12 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Find the connected components of an undirected graph
   ///
   /// Find the connected components of an undirected graph.
+  ///
+  /// \image html connected_components.png
+  /// \image latex connected_components.eps "Connected components" width=\textwidth
   ///
   /// \param graph The graph. It must be undirected.
@@ -118,5 +121,4 @@
   /// set continuously.
   /// \return The number of components
-  ///
   template <class Graph, class NodeMap>
   int connectedComponents(const Graph &graph, NodeMap &compMap) {
@@ -228,5 +230,5 @@
 
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Check whether the given directed graph is strongly connected.
@@ -286,5 +288,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Count the strongly connected components of a directed graph
@@ -350,5 +352,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Find the strongly connected components of a directed graph
@@ -362,4 +364,7 @@
   /// a lower.
   ///
+  /// \image html strongly_connected_components.png
+  /// \image latex strongly_connected_components.eps "Strongly connected components" width=\textwidth
+  ///
   /// \param digraph The digraph.
   /// \retval compMap A writable node map. The values will be set from 0 to
@@ -368,5 +373,4 @@
   /// will be set continuously.
   /// \return The number of components
-  ///
   template <typename Digraph, typename NodeMap>
   int stronglyConnectedComponents(const Digraph& digraph, NodeMap& compMap) {
@@ -417,5 +421,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Find the cut arcs of the strongly connected components.
@@ -701,5 +705,5 @@
   int countBiNodeConnectedComponents(const Graph& graph);
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Checks the graph is bi-node-connected.
@@ -716,5 +720,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Count the biconnected components.
@@ -751,5 +755,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Find the bi-node-connected components.
@@ -759,4 +763,7 @@
   /// relation on the undirected edges. Two undirected edge are in relationship
   /// when they are on same circle.
+  ///
+  /// \image html node_biconnected_components.png
+  /// \image latex node_biconnected_components.eps "bi-node-connected components" width=\textwidth
   ///
   /// \param graph The graph.
@@ -766,5 +773,4 @@
   /// will be set continuously.
   /// \return The number of components.
-  ///
   template <typename Graph, typename EdgeMap>
   int biNodeConnectedComponents(const Graph& graph,
@@ -794,5 +800,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Find the bi-node-connected cut nodes.
@@ -1024,5 +1030,5 @@
   int countBiEdgeConnectedComponents(const Graph& graph);
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Checks that the graph is bi-edge-connected.
@@ -1039,5 +1045,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Count the bi-edge-connected components.
@@ -1074,5 +1080,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Find the bi-edge-connected components.
@@ -1082,4 +1088,7 @@
   /// relation on the nodes. Two nodes are in relationship when they are
   /// connected at least two edge-disjoint paths.
+  ///
+  /// \image html edge_biconnected_components.png
+  /// \image latex edge_biconnected_components.eps "bi-edge-connected components" width=\textwidth
   ///
   /// \param graph The graph.
@@ -1089,5 +1098,4 @@
   /// will be set continuously.
   /// \return The number of components.
-  ///
   template <typename Graph, typename NodeMap>
   int biEdgeConnectedComponents(const Graph& graph, NodeMap& compMap) {
@@ -1116,5 +1124,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Find the bi-edge-connected cut edges.
@@ -1180,5 +1188,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Sort the nodes of a DAG into topolgical order.
@@ -1219,5 +1227,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Sort the nodes of a DAG into topolgical order.
@@ -1274,5 +1282,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Check that the given directed graph is a DAG.
@@ -1316,5 +1324,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Check that the given undirected graph is acyclic.
@@ -1350,5 +1358,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Check that the given undirected graph is tree.
@@ -1442,5 +1450,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Check if the given undirected graph is bipartite or not
@@ -1479,5 +1487,5 @@
   }
 
-  /// \ingroup connectivity
+  /// \ingroup graph_properties
   ///
   /// \brief Check if the given undirected graph is bipartite or not
@@ -1487,4 +1495,8 @@
   /// During the execution, the \c partMap will be set as the two
   /// partitions of the graph.
+  ///
+  /// \image html bipartite_partitions.png
+  /// \image latex bipartite_partitions.eps "Bipartite partititions" width=\textwidth
+  ///
   /// \param graph The undirected graph.
   /// \retval partMap A writable bool map of nodes. It will be set as the